#include	"compiler.h"
#include	<ddraw.h>
#include	"resource.h"
#include	"dd2.h"
#include	"keydisp.h"
#include	"keydisps.h"
#include	"keydispr.h"
#include	"pccore.h"
#include	"iocore.h"
#include	"sound.h"
#include	"fmboard.h"


typedef struct {
	BYTE	ch;
	BYTE	key;
} KDDELAY_EVENT;

#define	KDDELAY_EVENTS	2048

	KDDELAY_EVENT	kddl_e[KDDELAY_EVENTS];
	DWORD			kddl_pos = 0;
	DWORD			kddl_rem = 0;
	BYTE			kddl_warm = 0;
	BYTE			kddl_warmbase = 0;


void keydispr_delayinit(BYTE warm) {

	kddl_warmbase = warm;
	keydispr_delayreinit();
}

void keydispr_delayreinit(void) {

	kddl_warm = kddl_warmbase;
	kddl_pos = 0;
	kddl_rem = 0;
	ZeroMemory(kddl_e, sizeof(kddl_e));
	keydisps_alloff();
}

void keydispr_delay(BYTE cnt) {

	while(cnt--) {
		if (kddl_warm) {
			kddl_warm--;
			if (kddl_rem >= KDDELAY_EVENTS) {
				kddl_rem--;
				if (kddl_e[kddl_pos].ch == 0xff) {
					kddl_rem++;
				}
				else if (kddl_e[kddl_pos].key & 0x80) {
					keydisps_keyon(kddl_e[kddl_pos].ch, kddl_e[kddl_pos].key);
				}
				else {
					keydisps_keyoff(kddl_e[kddl_pos].ch, kddl_e[kddl_pos].key);
				}
				kddl_pos++;
			}
		}
		else {
			while(kddl_rem) {
				kddl_rem--;
				if (kddl_e[kddl_pos].ch == 0xff) {
					kddl_pos++;
					kddl_pos &= (KDDELAY_EVENTS - 1);
					break;
				}
				if (kddl_e[kddl_pos].key & 0x80) {
					keydisps_keyon(kddl_e[kddl_pos].ch, kddl_e[kddl_pos].key);
				}
				else {
					keydisps_keyoff(kddl_e[kddl_pos].ch, kddl_e[kddl_pos].key);
				}
				kddl_pos++;
				kddl_pos &= (KDDELAY_EVENTS - 1);
			}
		}
		kddl_e[(kddl_pos + kddl_rem) & (KDDELAY_EVENTS - 1)].ch = 0xff;
		kddl_rem++;
	}
}


static void delaysetevent(BYTE ch, BYTE key) {

	if (kddl_rem < KDDELAY_EVENTS) {
		DWORD pos;
		pos = (kddl_pos + kddl_rem) & (KDDELAY_EVENTS - 1);
		kddl_e[pos].ch = ch;
		kddl_e[pos].key = key;
		kddl_rem++;
	}
	else {
		if (kddl_e[kddl_pos].ch == 0xff) {
			kddl_warm++;
		}
		else if (kddl_e[kddl_pos].key & 0x80) {
			keydisps_keyon(kddl_e[kddl_pos].ch, kddl_e[kddl_pos].key);
		}
		else {
			keydisps_keyoff(kddl_e[kddl_pos].ch, kddl_e[kddl_pos].key);
		}
		kddl_e[kddl_pos].ch = ch;
		kddl_e[kddl_pos].key = key;
		kddl_pos++;
	}
}



// ---- BOARD change...

		BYTE	kd_posmax;
static	BYTE	kd_fmmax;
static	BYTE	kd_psgmax;
static	BYTE	posfm[12];
static	UINT	regfm[12];
static	BYTE	pospsg[3];

static void *psgtbl[3] = {&psg1, &psg2, &psg3};

static void setfmhdl(BYTE items, UINT base) {

	while(items--) {
		if ((kd_posmax < KEYDISP_CHMAX) && (kd_fmmax < 12)) {
			posfm[kd_fmmax] = kd_posmax++;
			regfm[kd_fmmax] = base;
			kd_fmmax++;
			base++;
			if ((base & 3) == 3) {
				base += 0x100 - 3;
			}
		}
	}
}

static void setpsghdl(BYTE items) {

	while(items--) {
		if ((kd_posmax <= (KEYDISP_CHMAX - 3)) && (kd_psgmax < 3)) {
			pospsg[kd_psgmax++] = kd_posmax;
			kd_posmax += 3;
		}
	}
}

void keydispr_setfmboard(BYTE b) {

	kd_posmax = 0;
	kd_fmmax = 0;
	kd_psgmax = 0;

	if (b & 0x02) {
		if (!(b & 0x04)) {
			setfmhdl(3, 0);
		}
		else {								// Qh̎WX^ړ
			setfmhdl(3, 0x200);
		}
		setpsghdl(1);
	}
	if (b & 0x04) {
		setfmhdl(6, 0);
		setpsghdl(1);
	}
	if (b & 0x08) {
		setfmhdl(6, 0);
		setpsghdl(1);
	}
	if (b & 0x20) {
		setfmhdl(6, 0);
		setpsghdl(1);
	}
	if (b & 0x40) {
		setfmhdl(12, 0);
		setpsghdl(1);
	}
	if (b & 0x80) {
		setpsghdl(3);
	}
	keydispr_delayreinit();
	keydispr_fminit();
	keydispr_psginit();
}


// ---- FM

typedef struct {
	UINT16	fnum[4];
	BYTE	lastnote[4];
	BYTE	flag;
	BYTE	extflag;
} KDFM_CTRL;

static	KDFM_CTRL	kdfmctl[12];

enum {
	FNUM_MIN	= 599,
	FNUM_MAX	= 1199
};

static const UINT16 fnumtbl[12] = {635,673,713,755,800,848,
									898,951,1008,1068,1132, 0xffff};

// ߕB
// FOR I=0 TO 12:K=I-9:HZ# = 440*(2^((K*2-1)/24)):FM#=HZ#*(2^17)/55556!:PRINT INT(FM#);",";:NEXT

static BYTE getfmnote(UINT16 fnum) {

	BYTE	ret;
	int		i;

	ret = (fnum >> 11) & 7;
	ret *= 12;
	ret += 24;
	fnum &= 0x7ff;

	while(fnum < FNUM_MIN) {
		if (!ret) {
			return(0);
		}
		ret -= 12;
		fnum <<= 1;
	}
	while(fnum > FNUM_MAX) {
		fnum >>= 1;
		ret += 12;
	}
	for (i=0; fnum >= fnumtbl[i]; i++) {
		ret++;
	}
	if (ret > 127) {
		return(127);
	}
	return(ret);
}

static void fmkeyoff(BYTE ch, KDFM_CTRL *k) {

	delaysetevent(posfm[ch], k->lastnote[0]);
}

static void fmkeyon(BYTE ch, KDFM_CTRL *k) {

	UINT	reg;

	fmkeyoff(ch, k);
	reg = regfm[ch] + 0xa0;
	k->fnum[0] = ((opn.reg[reg + 4] & 0x3f) << 8) + opn.reg[reg];
	k->lastnote[0] = getfmnote(k->fnum[0]);
	delaysetevent(posfm[ch], k->lastnote[0] | 0x80);
}

void keydispr_fminit(void) {

	ZeroMemory(kdfmctl, sizeof(kdfmctl));
}

void keydispr_fmkeyon(BYTE ch, BYTE value) {

	if (ch < kd_fmmax) {
		KDFM_CTRL	*k;
		k = kdfmctl + ch;
		value &= 0xf0;
		if (k->flag != value) {
			if (value) {
				fmkeyon(ch, k);
			}
			else {
				fmkeyoff(ch, k);
			}
			k->flag = value;
		}
	}
}

void keydispr_fmsync(void) {

	BYTE		ch;
	KDFM_CTRL	*k;
	UINT16		reg;
	UINT16		fnum;

	for (ch=0, k=kdfmctl; ch<kd_fmmax; ch++, k++) {
		if (k->flag) {
			reg = regfm[ch] + 0xa0;
			fnum = ((opn.reg[reg + 4] & 0x3f) << 8) + opn.reg[reg];
			if (k->fnum[0] != fnum) {
				BYTE n;
				k->fnum[0] = fnum;
				n = getfmnote(fnum);
				if (k->lastnote[0] != n) {
					fmkeyoff(ch, k);
				}
				k->lastnote[0] = n;
				delaysetevent(posfm[ch], k->lastnote[0] | 0x80);
			}
		}
	}
}


// ---- PSG

typedef struct {
	UINT16	fto[4];
	BYTE	lastnote[4];
	BYTE	flag;
	BYTE	mix;
	BYTE	padding[2];
} KDPSG_CTRL;

static	KDPSG_CTRL	kdpsgctl[3];


enum {
	FTO_MAX		= 491,
	FTO_MIN		= 245
};

static const UINT16 ftotbl[12] = {464,438,413,390,368,347,
									328,309,292,276,260, 0};

// ߕB
// FOR I=0 TO 12:K=I-9:HZ# = 440*(2^((K*2-1)/24)):PSG#=4000000#*(32*HZ#):PRINT INT(PSG#);",";:NEXT

static BYTE getpsgnote(UINT16 tone) {

	BYTE	ret;
	int		i;

	ret = 60;
	tone &= 0xfff;

	while(tone < FTO_MIN) {
		tone <<= 1;
		ret += 12;
		if (ret >= 128) {
			return(127);
		}
	}
	while(tone > FTO_MAX) {
		if (!ret) {
			return(0);
		}
		tone >>= 1;
		ret -= 12;
	}
	for (i=0; tone < ftotbl[i]; i++) {
		ret++;
	}
	if (ret >= 128) {
		return(127);
	}
	return(ret);
}

static void psgmix(BYTE ch, PSGGEN psg) {

	KDPSG_CTRL	*k;

	k = kdpsgctl + ch;
	if ((k->mix ^ psg->reg.mixer) & 7) {
		BYTE i, bit, pos;
		k->mix = psg->reg.mixer;
		pos = pospsg[ch];
		for (i=0, bit=1; i<3; i++, pos++, bit<<=1) {
			if (k->flag & bit) {
				k->flag ^= bit;
				delaysetevent(pos, k->lastnote[i]);
			}
			else if ((!(k->mix & bit)) && (psg->reg.vol[i] & 0x1f)) {
				k->flag |= bit;
				k->fto[i] = (*(WORD *)(psg->reg.tune[i])) & 0xfff;
				k->lastnote[i] = getpsgnote(k->fto[i]);
				delaysetevent(pos, k->lastnote[i] | 0x80);
			}
		}
	}
}

static void psgvol(BYTE ch, PSGGEN psg, BYTE i) {

	KDPSG_CTRL	*k;
	BYTE		bit;
	BYTE		pos;

	k = kdpsgctl + ch;
	bit = (1 << i);
	pos = pospsg[ch] + i;
	if (psg->reg.vol[i] & 0x1f) {
		if (!((k->mix | k->flag) & bit)) {
			k->flag |= bit;
			k->fto[i] = (*(WORD *)(psg->reg.tune[i])) & 0xfff;
			k->lastnote[i] = getpsgnote(k->fto[i]);
			delaysetevent(pos, k->lastnote[i] | 0x80);
		}
	}
	else if (k->flag & bit) {
		k->flag ^= bit;
		delaysetevent(pos, k->lastnote[i]);
	}
}

void keydispr_psginit(void) {

	ZeroMemory(kdpsgctl, sizeof(kdpsgctl));
}

void keydispr_psgmix(void *psg) {

	BYTE	c;

	for (c=0; c<kd_psgmax; c++) {
		if (psgtbl[c] == psg) {
			psgmix(c, (PSGGEN)psg);
			break;
		}
	}
}

void keydispr_psgvol(void *psg, BYTE ch) {

	BYTE	c;

	for (c=0; c<kd_psgmax; c++) {
		if (psgtbl[c] == psg) {
			psgvol(c, (PSGGEN)psg, ch);
			break;
		}
	}
}

void keydispr_psgsync(void) {

	BYTE		ch;
	KDPSG_CTRL	*k;
	BYTE		bit;
	BYTE		i;
	BYTE		pos;
	PSGGEN		psg;

	for (ch=0, k=kdpsgctl; ch<kd_psgmax; ch++, k++) {
		psg = (PSGGEN)psgtbl[ch];
		pos = pospsg[ch];
		for (i=0, bit=1; i<3; i++, pos++, bit<<=1) {
			if (k->flag & bit) {
				if ((k->fto[i] ^ (*(WORD *)(psg->reg.tune[i]))) & 0xfff) {
					BYTE n;
					k->fto[i] = (*(WORD *)(psg->reg.tune[i])) & 0xfff;
					n = getpsgnote(k->fto[i]);
					if (k->lastnote[i] != n) {
						delaysetevent(pos, k->lastnote[i]);
						k->lastnote[i] = n;
						delaysetevent(pos, n | 0x80);
					}
				}
			}
		}
	}
}


// ---- MIDI

void keydispr_midi(const BYTE *cmd) {

	switch(cmd[0] & 0xf0) {
		case 0x80:
			keydisps_keyoff(cmd[0] & 0x0f, cmd[1]);
			break;

		case 0x90:
			if (cmd[2] & 0x7f) {
				keydisps_keyon(cmd[0] & 0x0f, cmd[1]);
			}
			else {
				keydisps_keyoff(cmd[0] & 0x0f, cmd[1]);
			}
			break;

		case 0xb0:
			if ((cmd[1] == 0x7b) || (cmd[1] == 0x78)) {
				keydisps_keyalloff(cmd[0] & 0x0f);
			}
			break;

		case 0xfe:
			keydisps_alloff();
			break;
	}
}

