#include	"compiler.h"
#include	<ddraw.h>
#include	"resource.h"
#include	"dd2.h"
#include	"dd2sub.h"
#include	"keydisp.h"
#include	"keydisps.h"


static const BYTE keybrd1[] = {					// ՁB
				28, 14,
				0xc4, 0x6c, 0x44, 0x60,
				0xc4, 0x6c, 0x44, 0x60,
				0xc4, 0x6c, 0x44, 0x60,
				0xc4, 0x6c, 0x44, 0x60,
				0xc4, 0x6c, 0x44, 0x60,
				0xc4, 0x6c, 0x44, 0x60,
				0xc4, 0x6c, 0x44, 0x60,
				0xc4, 0x6c, 0x44, 0x60,
				0xee, 0xee, 0xee, 0xe0,
				0xee, 0xee, 0xee, 0xe0,
				0xee, 0xee, 0xee, 0xe0,
				0xee, 0xee, 0xee, 0xe0,
				0xee, 0xee, 0xee, 0xe0,
				0x00, 0x00, 0x00, 0x00};

static const BYTE keybrd2[] = {					//  GŐ؂B
				20, 14,
				0xc4, 0x6c, 0x40,
				0xc4, 0x6c, 0x40,
				0xc4, 0x6c, 0x40,
				0xc4, 0x6c, 0x40,
				0xc4, 0x6c, 0x40,
				0xc4, 0x6c, 0x40,
				0xc4, 0x6c, 0x40,
				0xc4, 0x6c, 0x40,
				0xee, 0xee, 0xe0,
				0xee, 0xee, 0xe0,
				0xee, 0xee, 0xe0,
				0xee, 0xee, 0xe0,
				0xee, 0xee, 0xe0,
				0x00, 0x00, 0x00};

static const BYTE keybrd_s1[] = {				// C, F
				3, 13,
				0xc0, 0xc0, 0xc0, 0xc0,
				0xc0, 0xc0, 0xc0, 0xc0,
				0xe0, 0xe0, 0xe0, 0xe0,
				0xe0};

static const BYTE keybrd_s2[] = {				// D, G, A
				3, 13,
				0x40, 0x40, 0x40, 0x40,
				0x40, 0x40, 0x40, 0x40,
				0xe0, 0xe0, 0xe0, 0xe0,
				0xe0};

static const BYTE keybrd_s3[] = {				// E, B
				3, 13,
				0x60, 0x60, 0x60, 0x60,
				0x60, 0x60, 0x60, 0x60,
				0xe0, 0xe0, 0xe0, 0xe0,
				0xe0};

static const BYTE keybrd_s4[] = {				// C+, D+, F+, G+, A+
				3, 8,
				0xe0, 0xe0, 0xe0, 0xe0,
				0xe0, 0xe0, 0xe0, 0xe0};

typedef struct {
	 WORD	posx;
	 WORD	pals;
const void	*data;
} KEYPOS_X;


#define	KDPALMAXBIT	4
#define	KDPALMAX	(1 << KDPALMAXBIT)

const KEYPOS_X keyposdef[12] = {
				{ 0, 0, keybrd_s1}, { 2, KDPALMAX, keybrd_s4},
				{ 4, 0, keybrd_s2}, { 6, KDPALMAX, keybrd_s4},
				{ 8, 0, keybrd_s3}, {12, 0, keybrd_s1},
				{14, KDPALMAX, keybrd_s4}, {16, 0, keybrd_s2},
				{18, KDPALMAX, keybrd_s4}, {20, 0, keybrd_s2},
				{22, KDPALMAX, keybrd_s4}, {24, 0, keybrd_s3}};



#ifdef __cplusplus
extern "C" {
#endif
		KEYDISP_CH	kd_ch[KEYDISP_CHMAX];
		KEYPOS_X	keypos[128];
#ifdef __cplusplus
}
#endif


WORD	kdpal16[KDPALMAX*2];
DWORD	kdpal32[KDPALMAX*2];


void keydisps_reload(void) {

	int		i;

	for (i=0; i<KEYDISP_CHMAX; i++) {
		kd_ch[i].flag = 2;
	}
}

void keydisps_clear(void) {

	ZeroMemory(kd_ch, sizeof(kd_ch));
	keydisps_reload();
}


void keydisps_init(void) {

	int		r, i;
	WORD	x;

	r = 0;
	x = 0;
	while(r<128) {
		for (i=0; i<12 && r<128; i++, r++) {
			keypos[r].posx = keyposdef[i].posx + x;
			keypos[r].pals = keyposdef[i].pals;
			keypos[r].data = keyposdef[i].data;
		}
		x += 28;
	}
	keydisps_clear();
}


void keydisps_palinit(DD2_T *dd2) {

	DWORD	i;

	for (i=0; i<(KDPALMAX-1); i++) {
		DWORD b = (0xc0 * i) / KDPALMAX;
		DWORD w = 0xff - b;
		kdpal32[i] = (w * 0x000101) + 0xff0000;
		kdpal32[KDPALMAX + i] = b << 16;
	}
	kdpal32[KDPALMAX - 1] = 0xff0000;
	kdpal32[KDPALMAX*2 - 1] = 0xff0000;
	if (dd2->vram.bit == 16) {
		for (i=0; i<(KDPALMAX*2); i++) {
			kdpal16[i] = dd2_get16pal(dd2, kdpal32[i]);
		}
	}
}


// ----

static void keydisps_cls(DD2_VRAM *vram) {

	int		i;

	switch(vram->bit) {
		case 8:
			for (i=0; i<10; i++) {
				dd2sub8_putbit1(vram, keybrd1, i * KEYDISP_KEYCX, 0, 0, 255);
			}
			dd2sub8_putbit1(vram, keybrd2, 10 * KEYDISP_KEYCX, 0, 0, 255);
			break;

		case 16:
			for (i=0; i<10; i++) {
				dd2sub16_putbit1(vram, keybrd1, i * KEYDISP_KEYCX, 0,
											kdpal16[KDPALMAX], kdpal16[0]);
			}
			dd2sub16_putbit1(vram, keybrd2, 10 * KEYDISP_KEYCX, 0,
											kdpal16[KDPALMAX], kdpal16[0]);
			break;

		case 24:
			for (i=0; i<10; i++) {
				dd2sub24_putbit1(vram, keybrd1, i * KEYDISP_KEYCX, 0,
											kdpal32[KDPALMAX], kdpal32[0]);
			}
			dd2sub24_putbit1(vram, keybrd2, 10 * KEYDISP_KEYCX, 0,
											kdpal32[KDPALMAX], kdpal32[0]);
			break;

		case 32:
			for (i=0; i<10; i++) {
				dd2sub32_putbit1(vram, keybrd1, i * KEYDISP_KEYCX, 0,
											kdpal32[KDPALMAX], kdpal32[0]);
			}
			dd2sub32_putbit1(vram, keybrd2, 10 * KEYDISP_KEYCX, 0,
											kdpal32[KDPALMAX], kdpal32[0]);
			break;
	}
}


static BOOL keydisps_1key(DD2_VRAM *vram, BYTE *c) {

	KEYPOS_X	*pos;
	DWORD		pal;

	pos = keypos + (c[0] & 0x7f);
	pal = c[KEYDISP_NOTEMAX] & 0x7f;
	switch(vram->bit) {
		case 8:
			if (pal != (KDPALMAX-1)) {
				BYTE p;
				p = ((pos->pals)?0:255);
				dd2sub8_forebit1(vram, pos->data, pos->posx, 0, p);
				c[KEYDISP_NOTEMAX] = 0;
				return(TRUE);
			}
			dd2sub8_forebit1(vram, pos->data, pos->posx, 0, 249);
			break;

		case 16:
			dd2sub16_forebit1(vram, pos->data, pos->posx, 0,
											kdpal16[pal + pos->pals]);
			break;

		case 24:
			dd2sub24_forebit1(vram, pos->data, pos->posx, 0,
											kdpal32[pal + pos->pals]);
			break;

		case 32:
			dd2sub32_forebit1(vram, pos->data, pos->posx, 0,
											kdpal32[pal + pos->pals]);
			break;
	}
	return(FALSE);
}


static BOOL keydisps_1ch(DD2_VRAM *vram, BYTE cnt, KEYDISP_CH *kdch) {

	BYTE	ret;

	ret = FALSE;
	if (kdch->flag & 2) {
		keydisps_cls(vram);
		ret = TRUE;
	}
	if (kdch->flag) {
		DWORD	i;
		BOOL	coll = FALSE;
		BYTE	nextf = 0;

		for (i=0; i<kdch->remain; i++) {
			if ((kdch->r[i] & 0x80) || (kdch->flag & 2)) {
				kdch->r[i] &= ~0x80;
				if (kdch->r[i] < (KDPALMAX-1)) {
					if (kdch->r[i] > cnt) {
						kdch->r[i] -= cnt;
						kdch->r[i] |= 0x80;
						nextf = 1;
					}
					else {
						kdch->r[i] = 0;
						coll = TRUE;
					}
				}
				coll |= keydisps_1key(vram, kdch->k + i);
			}
		}
		if (coll) {
			DWORD	j;
			for (i=0; i<kdch->remain; i++) {
				if (!kdch->r[i]) {
					break;
				}
			}
			for (j=i; i<kdch->remain; i++) {
				if (kdch->r[i]) {
					kdch->k[j] = kdch->k[i];
					kdch->r[j] = kdch->r[i];
					j++;
				}
			}
			kdch->remain = j;
		}
		kdch->flag = nextf;
		ret |= nextf;
	}
	return(ret);
}



BOOL keydisps_put(DD2_VRAM *vram, BYTE cnt) {

	int			i;
	KEYDISP_CH	*p;
	BOOL		ret = FALSE;

	for (i=0, p=kd_ch; i<KEYDISP_CHMAX; i++, p++) {
		ret |= keydisps_1ch(vram, cnt, p);
		vram->ptr += KEYDISP_KEYCY * vram->align;
	}
	return(ret);
}


// ----

void keydisps_keyon(BYTE ch, BYTE note) {

	DWORD	i;
	KEYDISP_CH	*kdch;

	note &= 0x7f;
	kdch = kd_ch + ch;
	for (i=0; i<kdch->remain; i++) {
		if (kdch->k[i] == note) {				// qbg
			for (; i<(kdch->remain-1); i++) {
				kdch->k[i] = kdch->k[i+1];
				kdch->r[i] = kdch->r[i+1];
			}
			kdch->k[i] = note;
			kdch->r[i] = 0x80 | (KDPALMAX-1);
			kdch->flag |= 1;
			return;
		}
	}
	if (i < KEYDISP_NOTEMAX) {
		kdch->k[i] = note;
		kdch->r[i] = 0x80 | (KDPALMAX-1);
		kdch->flag |= 1;
		kdch->remain++;
	}
}

void keydisps_keyoff(BYTE ch, BYTE note) {

	DWORD	i;
	KEYDISP_CH	*kdch;

	note &= 0x7f;
	kdch = kd_ch + ch;
	for (i=0; i<kdch->remain; i++) {
		if (kdch->k[i] == note) {				// qbg
			kdch->r[i] = 0x80 | (KDPALMAX-2);
			kdch->flag |= 1;
			break;
		}
	}
}

void keydisps_keyalloff(BYTE ch) {

	DWORD		i;
	KEYDISP_CH	*kdch;

	kdch = kd_ch + ch;
	for (i=0; i<kdch->remain; i++) {
		if ((kdch->r[i] & (~0x80)) >= (KDPALMAX-1)) {
			kdch->r[i] = 0x80 | (KDPALMAX-2);
			kdch->flag |= 1;
		}
	}
}

void keydisps_alloff(void) {

	BYTE	i;

	for (i=0; i<KEYDISP_CHMAX; i++) {
		keydisps_keyalloff(i);
	}
}

